using System;
using System.Collections.Generic;
using System.Data;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace CallCenterApi.BLL
{
    /// <summary>
	/// T_Cus_CustomerBase
	/// </summary>
	public partial class T_Cus_CustomerBase
    {
        private readonly CallCenterApi.DAL.T_Cus_CustomerBase dal = new CallCenterApi.DAL.T_Cus_CustomerBase();
        public T_Cus_CustomerBase()
        { }
        #region  BasicMethod

        /// <summary>
        /// 得到最大ID
        /// </summary>
        public int GetMaxId()
        {
            return dal.GetMaxId();
        }

        /// <summary>
        /// 是否存在该记录
        /// </summary>
        public bool Exists(int F_CustomerId)
        {
            return dal.Exists(F_CustomerId);
        }

        /// <summary>
        /// 增加一条数据
        /// </summary>
        public int Add(CallCenterApi.Model.T_Cus_CustomerBase model)
        {
            return dal.Add(model);
        }

        /// <summary>
        /// 更新一条数据
        /// </summary>
        public bool Update(CallCenterApi.Model.T_Cus_CustomerBase model)
        {
            return dal.Update(model);
        }

        /// <summary>
        /// 删除一条数据
        /// </summary>
        public bool Delete(int F_CustomerId)
        {

            return dal.Delete(F_CustomerId);
        }
        /// <summary>
        /// 删除一条数据
        /// </summary>
        public bool DeleteList(string F_CustomerIdlist)
        {
            return dal.DeleteList(F_CustomerIdlist);
        }

        /// <summary>
        /// 得到一个对象实体
        /// </summary>
        public CallCenterApi.Model.T_Cus_CustomerBase GetModel(int F_CustomerId)
        {

            return dal.GetModel(F_CustomerId);
        }

        /// <summary>
        /// 获得数据列表
        /// </summary>
        public DataSet GetList(string strWhere)
        {
            return dal.GetList(strWhere);
        }
        /// <summary>
        /// 获得前几行数据
        /// </summary>
        public DataSet GetList(int Top, string strWhere, string filedOrder)
        {
            return dal.GetList(Top, strWhere, filedOrder);
        }
        /// <summary>
        /// 获得数据列表
        /// </summary>
        public List<CallCenterApi.Model.T_Cus_CustomerBase> GetModelList(string strWhere)
        {
            DataSet ds = dal.GetList(strWhere);
            return DataTableToList(ds.Tables[0]);
        }
        /// <summary>
        /// 获得数据列表
        /// </summary>
        public List<CallCenterApi.Model.T_Cus_CustomerBase> DataTableToList(DataTable dt)
        {
            List<CallCenterApi.Model.T_Cus_CustomerBase> modelList = new List<CallCenterApi.Model.T_Cus_CustomerBase>();
            int rowsCount = dt.Rows.Count;
            if (rowsCount > 0)
            {
                CallCenterApi.Model.T_Cus_CustomerBase model;
                for (int n = 0; n < rowsCount; n++)
                {
                    model = dal.DataRowToModel(dt.Rows[n]);
                    if (model != null)
                    {
                        modelList.Add(model);
                    }
                }
            }
            return modelList;
        }

        /// <summary>
        /// 获得数据列表
        /// </summary>
        public DataSet GetAllList()
        {
            return GetList("");
        }

        /// <summary>
        /// 分页获取数据列表
        /// </summary>
        public int GetRecordCount(string strWhere)
        {
            return dal.GetRecordCount(strWhere);
        }
        /// <summary>
        /// 分页获取数据列表
        /// </summary>
        public DataSet GetListByPage(string strWhere, string orderby, int startIndex, int endIndex)
        {
            return dal.GetListByPage(strWhere, orderby, startIndex, endIndex);
        }
        /// <summary>
        /// 分页获取数据列表
        /// </summary>
        //public DataSet GetList(int PageSize,int PageIndex,string strWhere)
        //{
        //return dal.GetList(PageSize,PageIndex,strWhere);
        //}
        /// <summary>
        /// 是否存在该记录
        /// </summary>
        public bool PhoneExists(string F_Mobile)
        {
            return dal.PhoneExists(F_Mobile);
        }
        /// <summary>
        /// 根据号码获取客户信息
        /// </summary>
        /// <param name="F_Mobile"></param>
        /// <returns></returns>
        public CallCenterApi.Model.T_Cus_CustomerBase GetModelByPhone(string F_Mobile)
        {
            return dal.GetModelByPhone(F_Mobile);
        }

        /// <summary>
        /// 删除一条数据
        /// </summary>
        public bool PhoneDelete(string F_Mobile)
        {

            return dal.PhoneDelete(F_Mobile);
        }
        #endregion  BasicMethod
        #region  ExtensionMethod
        /// <summary>
        /// 20180509
        /// zhengbingbing
        /// 根据号码获取客户信息
        /// </summary>
        public Model.T_Cus_CustomerBase GetModelByTel(string tel)
        {
            return dal.GetModelByTel(tel);
        }
        #endregion  ExtensionMethod
    }
}
